#include <stdio.h>
#include <tchar.h>
#include "Serial.h"	// Library described above
#include <string>
#include <time.h>

#define BYTES_IN_BUFFER		512

// application reads from the specified serial port and reports the collected data
int main(int argc, char* argv[])
{
	printf("Welcome to the serial test app!\n\n");

	Serial* SP = new Serial("COM6");    // adjust as needed

	if (SP->IsConnected())
		printf("We're connected");

	unsigned char incomingData[BYTES_IN_BUFFER] = "";
	WORD data[BYTES_IN_BUFFER/2];				
	int dataLength = BYTES_IN_BUFFER;
	clock_t clk = clock();
	unsigned int que, read = 0, total = 0, err=0, j;

	while (SP->IsConnected())
	{
		if (SP->ReadData((char *)incomingData, dataLength, &que)) 
		{
			for (int i = 0; i < BYTES_IN_BUFFER/2; i++)
			{
				data[i] = (incomingData[2 * i + 1] << 8) | (incomingData[2 * i] & 0xFF);
				j = data[i];

				if (j != i)
					err++;
			}
			read += BYTES_IN_BUFFER;
		}

		if (clock() - clk > CLOCKS_PER_SEC) 
		{
			system("cls");
			total += read;
			printf("Bytes read so far: %u B\nCurrent communication speed: %u B/s\nBytes in queue: %u B\nErrors: %d\n\n", total, read, que, err);
			read = 0;
			err = 0;
			clk = clock();
		}
	}

	return 0;
}